//
// Created by epagris on 2022.10.20..
//

#include "eth_interface.h"
#include "dynmem.h"
#include "utils.h"

static int ethintf_llrecv(EthIODef * io, const RawPckt * pckt) {
    ethinf_receive((EthInterface *) io->tag, pckt);
    return 0;
}

static void ethintf_register(EthInterface * intf) {
    intf->ioDef->tag = intf;
    intf->ioDef->llRxDone = ethintf_llrecv;
}

EthInterface *ethintf_new(EthIODef * io) {
    EthInterface * ethIntf = (EthInterface *)dynmem_alloc(sizeof(EthInterface));
    ASSERT_NULL(ethIntf);
    memset(&ethIntf->sieve.layer0, 0, sizeof(PcktSieveLayer));
    ethIntf->ioDef = io;
    ethintf_register(ethIntf);
    return ethIntf;
}

void ethinf_receive(EthInterface *intf, const RawPckt *rawPckt) {
    packsieve_input(&intf->sieve, rawPckt);
}

void ethinf_transmit(EthInterface *intf, const RawPckt *rawPckt) {
    intf->ioDef->llTx(&(intf->ioDef), rawPckt);
}
